function [A, converged] = opt(X, S, D, maxiter)

% each row is a example:

s = size(X);
N = s(1);     % number of examples
d = s(2);     % dimensionality of examples            

A = eye(d,d)*0.1;
W = zeros(d,d);

if size(S,1) == size(S,2) %%inefficient and very expensive for large data sets
    for i = 1:N,
        for j = i+1:N,
            if S(i,j) == 1,
                d_ij = X(i,:) - X(j,:);
                W = W + (d_ij'*d_ij);
            end;
        end;
    end;
else %%more efficient, a list of dissimilar samples
    for sample = 1:size(S,1)
        i = S(sample,1);
        j = S(sample,2);

        d_ij = X(i,:) - X(j,:);
        W = W + (d_ij'*d_ij);
    end
end
w = unroll(W);
t = w' * unroll(A)/100;

[A, converged] = iter_projection_new2(X, S, D, A, w, t, maxiter);
if converged==0
    display(' OH NOES!! IT DIDN`T CONVERGE!!!')
end  









